package api

import (
	"ArmedPolice/config"
	"ArmedPolice/utils"
	"strings"
)

type idForm struct {
	ID uint64 `json:"id" form:"id" binding:"required"`
}

type uidForm struct {
	UID string `json:"uid" form:"uid" binding:"required"`
}

func (this *uidForm) Convert() uint64 {
	return utils.StringToUnit64(this.UID)
}

type imageForm struct {
	Image string `json:"image" form:"image"`
}

func (this *imageForm) FilterImageURL() string {
	return strings.Replace(this.Image, config.SettingInfo.Domain, "", -1)
}

type positionForm struct {
	Longitude float64 `json:"longitude" form:"longitude" binding:"required"`
	Latitude  float64 `json:"latitude" form:"latitude" binding:"required"`
}

type pageForm struct {
	Page     int `json:"current" form:"current" binding:"required"`
	PageSize int `json:"pageSize" form:"pageSize" binding:"required"`
}
