package auth

import (
	model2 "ArmedPolice/app/common/model"
	"ArmedPolice/app/controller"
	"ArmedPolice/app/model"
	"ArmedPolice/app/service"
)

type Instance struct{ *controller.Platform }

type InstanceHandle func(session *service.Session) *Instance

// List 列表信息
func (c *Instance) List() ([]*Tree, error) {
	mSysAuth := model.NewSysAuth()

	where := []*model2.ModelWhereOrder{
		&model2.ModelWhereOrder{Order: model2.NewOrder("parent_id", model2.OrderModeToAsc)},
		&model2.ModelWhereOrder{Order: model2.NewOrder("sort", model2.OrderModeToDesc)},
	}
	out := make([]*model2.SysAuth, 0)

	if err := model2.Scan(mSysAuth, &out, where...); err != nil {
		return nil, err
	}
	return tree(out, 0), nil
}

func NewInstance() InstanceHandle {
	return func(session *service.Session) *Instance {
		return &Instance{Platform: &controller.Platform{Session: session}}
	}
}
