package controller

import (
	"ArmedPolice/app/service"
	"ArmedPolice/config"
	"ArmedPolice/serve/cache"
	"ArmedPolice/utils"
)

// Platform
type Platform struct{ *service.Session }

// ReturnPages 分页数据
type ReturnPages struct {
	List  interface{} `json:"list"`
	Count int64       `json:"total"`
}

type Key struct{}

// Generate 生成秘钥
func (*Key) Generate(len int) string {
	key := utils.GetRandomString(len)
	for {
		isExist, _ := cache.Cache.SIsMember(config.RedisKeyForTenantKeys, key)

		if !isExist {
			_ = cache.Cache.SAdd(config.RedisKeyForTenantKeys, key)
			return key
		}
		key = utils.GetRandomString(len)
	}
}
