package menu

import (
	model2 "ArmedPolice/app/common/model"
	"ArmedPolice/app/controller"
	"ArmedPolice/app/model"
	"ArmedPolice/app/service"
)

type User struct{ *controller.Platform }

type UserHandle func(session *service.Session) *User

// User 用户列表
func (c *User) List() (interface{}, error) {
	mSysMenu := model.NewSysMenu()

	if c.IsAdmin {
		return menuForSystem(mSysMenu)
	}
	mSysUserTenant := model.NewSysUserTenant()

	isExist, err := model2.FirstField(mSysUserTenant.SysUserTenant, []string{"id", "identity"},
		model2.NewWhere("tenant_id", c.TenantID),
		model2.NewWhere("uid", c.UID))

	if err != nil {
		return nil, err
	} else if !isExist {
		return nil, nil
	}
	if mSysUserTenant.Identity == model2.SysUserTenantIdentityForSystemAdmin {
		return menuForTenant(mSysMenu, c.TenantID)
	}
	return menuForUser(mSysMenu, c.TenantID, c.UID)
}

func NewUser() UserHandle {
	return func(session *service.Session) *User {
		return &User{Platform: &controller.Platform{Session: session}}
	}
}
