package service

import (
	"ArmedPolice/utils"
	"encoding/json"
)

type Session struct {
	UID        uint64 `json:"uid"`         // 用户ID
	Token      string `json:"token"`       // token
	TenantID   uint64 `json:"tenant_id"`   // 租户ID
	Name       string `json:"name"`        // 名称
	SessionKey string `json:"session_key"` // 用户信息
}

func (this *Session) MarshalBinary() ([]byte, error) {
	return json.Marshal(this)
}

func (this *Session) UnmarshalBinary(data []byte) error {
	return utils.FromJSONBytes(data, this)
}

func (this *Session) UIDToString() string {
	return utils.UintToString(this.UID)
}

func NewSession() *Session {
	return &Session{}
}
